common.rc 12.1 KB
Newer Older
1
#!/bin/bash
2 3 4 5 6 7 8 9 10 11 12 13 14 15 16
#
# Copyright (C) 2009 Red Hat, Inc.
# Copyright (c) 2000-2006 Silicon Graphics, Inc.  All Rights Reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
17
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
18 19 20 21 22
#

dd()
{
   if [ "$HOSTOS" == "Linux" ]
K
Kevin Wolf 已提交
23 24 25 26 27 28 29 30 31
   then
        command dd --help | grep noxfer > /dev/null 2>&1

        if [ "$?" -eq 0 ]
            then
                command dd status=noxfer $@
            else
                command dd $@
            fi
32
   else
K
Kevin Wolf 已提交
33
        command dd $@
34 35 36
   fi
}

37 38 39 40 41 42
# poke_file 'test.img' 512 '\xff\xfe'
poke_file()
{
    printf "$3" | dd "of=$1" bs=1 "seek=$2" conv=notrunc &>/dev/null
}

43 44 45 46 47 48 49 50 51 52 53 54 55
# we need common.config
if [ "$iam" != "check" ]
then
    if ! . ./common.config
        then
        echo "$iam: failed to source common.config"
        exit 1
    fi
fi

# make sure we have a standard umask
umask 022

56 57
if [ "$IMGPROTO" = "file" ]; then
    TEST_IMG=$TEST_DIR/t.$IMGFMT
58 59 60
elif [ "$IMGPROTO" = "nbd" ]; then
    TEST_IMG_FILE=$TEST_DIR/t.$IMGFMT
    TEST_IMG="nbd:127.0.0.1:10810"
61 62 63
elif [ "$IMGPROTO" = "ssh" ]; then
    TEST_IMG_FILE=$TEST_DIR/t.$IMGFMT
    TEST_IMG="ssh://127.0.0.1$TEST_IMG_FILE"
64 65 66
elif [ "$IMGPROTO" = "nfs" ]; then
    TEST_DIR="nfs://127.0.0.1/$TEST_DIR"
    TEST_IMG=$TEST_DIR/t.$IMGFMT
67 68
elif [ "$IMGPROTO" = "archipelago" ]; then
    TEST_IMG="archipelago:at.$IMGFMT"
69 70 71
else
    TEST_IMG=$IMGPROTO:$TEST_DIR/t.$IMGFMT
fi
72

K
Kevin Wolf 已提交
73 74 75 76 77 78 79 80 81 82
function valgrind_qemu_io()
{
    valgrind --log-file=/tmp/$$.valgrind --error-exitcode=99 $REAL_QEMU_IO "$@"
    if [ $? != 0 ]; then
        cat /tmp/$$.valgrind
    fi
    rm -f /tmp/$$.valgrind
}


83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98
_optstr_add()
{
    if [ -n "$1" ]; then
        echo "$1,$2"
    else
        echo "$2"
    fi
}

_set_default_imgopts()
{
    if [ "$IMGFMT" == "qcow2" ] && ! (echo "$IMGOPTS" | grep "compat=" > /dev/null); then
        IMGOPTS=$(_optstr_add "$IMGOPTS" "compat=1.1")
    fi
}

99 100 101 102 103 104 105 106 107 108 109 110
_use_sample_img()
{
    SAMPLE_IMG_FILE="${1%\.bz2}"
    TEST_IMG="$TEST_DIR/$SAMPLE_IMG_FILE"
    bzcat "$SAMPLE_IMG_DIR/$1" > "$TEST_IMG"
    if [ $? -ne 0 ]
    then
        echo "_use_sample_img error, cannot extract '$SAMPLE_IMG_DIR/$1'"
        exit 1
    fi
}

111 112 113 114
_make_test_img()
{
    # extra qemu-img options can be added by tests
    # at least one argument (the image size) needs to be added
115 116
    local extra_img_options=""
    local image_size=$*
117
    local optstr=""
118
    local img_name=""
119 120
    local use_backing=0
    local backing_file=""
121 122 123 124 125 126

    if [ -n "$TEST_IMG_FILE" ]; then
        img_name=$TEST_IMG_FILE
    else
        img_name=$TEST_IMG
    fi
127 128 129 130

    if [ -n "$IMGOPTS" ]; then
        optstr=$(_optstr_add "$optstr" "$IMGOPTS")
    fi
131

132
    if [ "$1" = "-b" ]; then
133 134
        use_backing=1
        backing_file=$2
135 136
        image_size=$3
    fi
137
    if [ \( "$IMGFMT" = "qcow2" -o "$IMGFMT" = "qed" \) -a -n "$CLUSTER_SIZE" ]; then
138 139 140 141 142
        optstr=$(_optstr_add "$optstr" "cluster_size=$CLUSTER_SIZE")
    fi

    if [ -n "$optstr" ]; then
        extra_img_options="-o $optstr $extra_img_options"
143 144
    fi

145
    # XXX(hch): have global image options?
146 147 148 149 150 151 152
    (
     if [ $use_backing = 1 ]; then
        $QEMU_IMG create -f $IMGFMT $extra_img_options -b "$backing_file" "$img_name" $image_size 2>&1
     else
        $QEMU_IMG create -f $IMGFMT $extra_img_options "$img_name" $image_size 2>&1
     fi
    ) | \
153 154 155 156 157 158 159 160 161
        sed -e "s#$IMGPROTO:$TEST_DIR#TEST_DIR#g" \
            -e "s#$TEST_DIR#TEST_DIR#g" \
            -e "s#$IMGFMT#IMGFMT#g" \
            -e "s# encryption=off##g" \
            -e "s# cluster_size=[0-9]\\+##g" \
            -e "s# table_size=[0-9]\\+##g" \
            -e "s# compat='[^']*'##g" \
            -e "s# compat6=\\(on\\|off\\)##g" \
            -e "s# static=\\(on\\|off\\)##g" \
162 163
            -e "s# zeroed_grain=\\(on\\|off\\)##g" \
            -e "s# subformat='[^']*'##g" \
164
            -e "s# adapter_type='[^']*'##g" \
165 166 167
            -e "s# lazy_refcounts=\\(on\\|off\\)##g" \
            -e "s# block_size=[0-9]\\+##g" \
            -e "s# block_state_zero=\\(on\\|off\\)##g" \
168 169
            -e "s# log_size=[0-9]\\+##g" \
            -e "s/archipelago:a/TEST_DIR\//g"
170 171 172 173 174 175 176

    # Start an NBD server on the image file, which is what we'll be talking to
    if [ $IMGPROTO = "nbd" ]; then
        eval "$QEMU_NBD -v -t -b 127.0.0.1 -p 10810  $TEST_IMG_FILE &"
        QEMU_NBD_PID=$!
        sleep 1 # FIXME: qemu-nbd needs to be listening before we continue
    fi
177 178
}

179 180 181 182 183
_rm_test_img()
{
    local img=$1
    if [ "$IMGFMT" = "vmdk" ]; then
        # Remove all the extents for vmdk
184
        "$QEMU_IMG" info "$img" 2>/dev/null | grep 'filename:' | cut -f 2 -d: \
185 186
            | xargs -I {} rm -f "{}"
    fi
187
    rm -f "$img"
188 189
}

190 191
_cleanup_test_img()
{
192 193
    case "$IMGPROTO" in

194 195
        nbd)
            kill $QEMU_NBD_PID
196
            rm -f "$TEST_IMG_FILE"
197
            ;;
198
        file)
199 200 201
            _rm_test_img "$TEST_DIR/t.$IMGFMT"
            _rm_test_img "$TEST_DIR/t.$IMGFMT.orig"
            _rm_test_img "$TEST_DIR/t.$IMGFMT.base"
202 203 204 205
            if [ -n "$SAMPLE_IMG_FILE" ]
            then
                rm -f "$TEST_DIR/$SAMPLE_IMG_FILE"
            fi
206 207 208
            ;;

        rbd)
209
            rbd --no-progress rm "$TEST_DIR/t.$IMGFMT" > /dev/null
210 211
            ;;

212 213 214 215
        archipelago)
            vlmc remove "at.$IMGFMT" > /dev/null
            ;;

216
        sheepdog)
217
            collie vdi delete "$TEST_DIR/t.$IMGFMT"
218 219 220
            ;;

    esac
221 222 223 224
}

_check_test_img()
{
225
    $QEMU_IMG check "$@" -f $IMGFMT "$TEST_IMG" 2>&1 | _filter_testdir | \
226
        sed -e '/allocated.*fragmented.*compressed clusters/d' \
227 228
            -e 's/qemu-img: This image format does not support checks/No errors were found on the image./' \
            -e '/Image end offset: [0-9]\+/d'
229 230
}

231 232
_img_info()
{
233 234
    discard=0
    regex_json_spec_start='^ *"format-specific": \{'
235
    $QEMU_IMG info "$@" "$TEST_IMG" 2>&1 | \
236 237 238 239
        sed -e "s#$IMGPROTO:$TEST_DIR#TEST_DIR#g" \
            -e "s#$TEST_DIR#TEST_DIR#g" \
            -e "s#$IMGFMT#IMGFMT#g" \
            -e "/^disk size:/ D" \
240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256
            -e "/actual-size/ D" | \
        while IFS='' read line; do
            if [[ $line == "Format specific information:" ]]; then
                discard=1
            elif [[ $line =~ $regex_json_spec_start ]]; then
                discard=2
                regex_json_spec_end="^${line%%[^ ]*}\\},? *$"
            fi
            if [[ $discard == 0 ]]; then
                echo "$line"
            elif [[ $discard == 1 && ! $line ]]; then
                echo
                discard=0
            elif [[ $discard == 2 && $line =~ $regex_json_spec_end ]]; then
                discard=0
            fi
        done
257 258
}

259 260 261 262
_get_pids_by_name()
{
    if [ $# -ne 1 ]
    then
K
Kevin Wolf 已提交
263 264
        echo "Usage: _get_pids_by_name process-name" 1>&2
        exit 1
265 266 267 268 269 270 271 272 273 274 275
    fi

    # Algorithm ... all ps(1) variants have a time of the form MM:SS or
    # HH:MM:SS before the psargs field, use this as the search anchor.
    #
    # Matches with $1 (process-name) occur if the first psarg is $1
    # or ends in /$1 ... the matching uses sed's regular expressions,
    # so passing a regex into $1 will work.

    ps $PS_ALL_FLAGS \
    | sed -n \
K
Kevin Wolf 已提交
276 277 278 279 280 281
        -e 's/$/ /' \
        -e 's/[         ][         ]*/ /g' \
        -e 's/^ //' \
        -e 's/^[^ ]* //' \
        -e "/[0-9]:[0-9][0-9]  *[^ ]*\/$1 /s/ .*//p" \
        -e "/[0-9]:[0-9][0-9]  *$1 /s/ .*//p"
282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298
}

# fqdn for localhost
#
_get_fqdn()
{
    host=`hostname`
    $NSLOOKUP_PROG $host | $AWK_PROG '{ if ($1 == "Name:") print $2 }'
}

# check if run as root
#
_need_to_be_root()
{
    id=`id | $SED_PROG -e 's/(.*//' -e 's/.*=//'`
    if [ "$id" -ne 0 ]
    then
K
Kevin Wolf 已提交
299 300
        echo "Arrgh ... you need to be root (not uid=$id) to run this test"
        exit 1
301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317
    fi
}


# Do a command, log it to $seq.full, optionally test return status
# and die if command fails. If called with one argument _do executes the
# command, logs it, and returns its exit status. With two arguments _do
# first prints the message passed in the first argument, and then "done"
# or "fail" depending on the return status of the command passed in the
# second argument. If the command fails and the variable _do_die_on_error
# is set to "always" or the two argument form is used and _do_die_on_error
# is set to "message_only" _do will print an error message to
# $seq.out and exit.

_do()
{
    if [ $# -eq 1 ]; then
K
Kevin Wolf 已提交
318
        _cmd=$1
319
    elif [ $# -eq 2 ]; then
K
Kevin Wolf 已提交
320 321 322
        _note=$1
        _cmd=$2
        echo -n "$_note... "
323
    else
K
Kevin Wolf 已提交
324 325
        echo "Usage: _do [note] cmd" 1>&2
        status=1; exit
326 327
    fi

M
Max Reitz 已提交
328
    (eval "echo '---' \"$_cmd\"") >>"$OUTPUT_DIR/$seq.full"
329
    (eval "$_cmd") >$tmp._out 2>&1; ret=$?
M
Max Reitz 已提交
330
    cat $tmp._out >>"$OUTPUT_DIR/$seq.full"
331
    if [ $# -eq 2 ]; then
K
Kevin Wolf 已提交
332 333 334 335 336
        if [ $ret -eq 0 ]; then
            echo "done"
        else
            echo "fail"
        fi
337 338
    fi
    if [ $ret -ne 0  ] \
K
Kevin Wolf 已提交
339 340
        && [ "$_do_die_on_error" = "always" \
            -o \( $# -eq 2 -a "$_do_die_on_error" = "message_only" \) ]
341
    then
K
Kevin Wolf 已提交
342 343 344
        [ $# -ne 2 ] && echo
        eval "echo \"$_cmd\" failed \(returned $ret\): see $seq.full"
        status=1; exit
345 346 347 348 349 350 351 352 353
    fi

    return $ret
}

# bail out, setting up .notrun file
#
_notrun()
{
M
Max Reitz 已提交
354
    echo "$*" >"$OUTPUT_DIR/$seq.notrun"
355 356 357 358 359 360 361 362 363
    echo "$seq not run: $*"
    status=0
    exit
}

# just plain bail out
#
_fail()
{
M
Max Reitz 已提交
364
    echo "$*" | tee -a "$OUTPUT_DIR/$seq.full"
365 366 367 368 369 370 371 372 373
    echo "(see $seq.full for details)"
    status=1
    exit 1
}

# tests whether $IMGFMT is one of the supported image formats for a test
#
_supported_fmt()
{
374 375 376
    # "generic" is suitable for most image formats. For some formats it doesn't
    # work, however (most notably read-only formats), so they can opt out by
    # setting IMGFMT_GENERIC to false.
377
    for f; do
378
        if [ "$f" = "$IMGFMT" -o "$f" = "generic" -a "$IMGFMT_GENERIC" = "true" ]; then
K
Kevin Wolf 已提交
379 380
            return
        fi
381 382 383 384 385
    done

    _notrun "not suitable for this image format: $IMGFMT"
}

386 387 388 389 390
# tests whether $IMGPROTO is one of the supported image protocols for a test
#
_supported_proto()
{
    for f; do
K
Kevin Wolf 已提交
391 392 393
        if [ "$f" = "$IMGPROTO" -o "$f" = "generic" ]; then
            return
        fi
394 395 396 397 398
    done

    _notrun "not suitable for this image protocol: $IMGPROTO"
}

399 400 401 402 403 404
# tests whether the host OS is one of the supported OSes for a test
#
_supported_os()
{
    for h
    do
K
Kevin Wolf 已提交
405 406 407 408
        if [ "$h" = "$HOSTOS" ]
        then
            return
        fi
409 410 411 412 413
    done

    _notrun "not suitable for this OS: $HOSTOS"
}

414
_supported_cache_modes()
415
{
416 417 418 419
    for mode; do
        if [ "$mode" = "$CACHEMODE" ]; then
            return
        fi
420
    done
421 422 423 424 425 426 427 428 429 430
    _notrun "not suitable for cache mode: $CACHEMODE"
}

_default_cache_mode()
{
    if $CACHEMODE_IS_DEFAULT; then
        CACHEMODE="$1"
        QEMU_IO="$QEMU_IO --cache $1"
        return
    fi
431 432
}

433 434 435 436 437 438 439 440 441 442 443
_unsupported_imgopts()
{
    for bad_opt
    do
        if echo "$IMGOPTS" | grep -q 2>/dev/null "$bad_opt"
        then
            _notrun "not suitable for image option: $bad_opt"
        fi
    done
}

444 445 446 447
# this test requires that a specified command (executable) exists
#
_require_command()
{
448 449
    eval c=\$$1
    [ -x "$c" ] || _notrun "$1 utility required, skipped this test"
450 451 452 453
}

_full_imgfmt_details()
{
454 455 456 457 458
    if [ -n "$IMGOPTS" ]; then
        echo "$IMGFMT ($IMGOPTS)"
    else
        echo "$IMGFMT"
    fi
459 460
}

461 462 463 464 465
_full_imgproto_details()
{
    echo "$IMGPROTO"
}

466 467 468 469 470 471 472 473 474 475 476 477 478 479 480 481 482 483 484 485 486 487 488 489 490 491 492 493 494 495 496 497 498 499
_full_platform_details()
{
    os=`uname -s`
    host=`hostname -s`
    kernel=`uname -r`
    platform=`uname -m`
    echo "$os/$platform $host $kernel"
}

_link_out_file()
{
   if [ -z "$1" ]; then
      echo Error must pass \$seq.
      exit
   fi
   rm -f $1
   if [ "`uname`" == "IRIX64" ] || [ "`uname`" == "IRIX" ]; then
      ln -s $1.irix $1
   elif [ "`uname`" == "Linux" ]; then
      ln -s $1.linux $1
   else
      echo Error test $seq does not run on the operating system: `uname`
      exit
   fi
}

_die()
{
        echo $@
        exit 1
}

# make sure this script returns success
/bin/true